export interface MatchPattern<T, S, N> {
    some: (_: T) => S;
    none: (() => N) | N;
}
export interface Option<T> {
    is_some(): boolean;
    is_none(): boolean;
    match<S, N>(p: MatchPattern<T, S, N>): S | N;
    map<U>(fn: (_: T) => U): Option<U>;
    and_then<U>(fn: (_: T) => Option<U>): Option<U>;
    or(optb: Option<T>): Option<T>;
    and(optb: Option<T>): Option<T>;
    unwrap_or(def: T): T;
    unwrap(): T | undefined;
}
export declare const assert_none: (_: any) => boolean;
export declare const assert_some: (_: any) => boolean;
export declare function is_some<T>(_: Option<T>): _ is _Some<T>;
export declare function is_none<T>(_: Option<T>): _ is _None<T>;
export declare function get_in(obj: Object | undefined | null, key: string): Option<any>;
export declare class _Some<T> implements Option<T> {
    protected readonly _: T;
    constructor(_: T);
    is_some(): boolean;
    is_none(): boolean;
    match<S, N>(p: MatchPattern<T, S, N>): S;
    map<U>(fn: (_: T) => U): Option<U>;
    and_then<U>(fn: (_: T) => Option<U>): Option<U>;
    or(optb: Option<T>): Option<T>;
    and(optb: Option<T>): Option<T>;
    unwrap(): T;
    unwrap_or(def: T): T;
}
export declare class _None<T> implements Option<any> {
    is_some(): boolean;
    is_none(): boolean;
    match<S, N>(p: MatchPattern<T, S, N>): N;
    map<U>(fn: (_: T) => U): Option<U>;
    and_then<U>(fn: (_: T) => Option<U>): Option<U>;
    or(optb: Option<T>): Option<T>;
    and(optb: Option<T>): Option<T>;
    unwrap(): never;
    unwrap_or(def: T): T;
}
export declare function Some<T>(_: T | null | undefined): _Some<T> | _None<T>;
export declare const None: _None<any>;
