"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assert_none = function (_) { return (_ == null); };
exports.assert_some = function (_) { return !exports.assert_none(_); };
function is_some(_) {
    return _.is_some();
}
exports.is_some = is_some;
function is_none(_) {
    return _.is_none();
}
exports.is_none = is_none;
function get_in(obj, key) {
    var val = key.split('.').reduce(function (o, x) { return o == null ? o : o[x]; }, obj);
    return Some(val);
}
exports.get_in = get_in;
var _Some = (function () {
    function _Some(_) {
        this._ = _;
    }
    _Some.prototype.is_some = function () {
        return true;
    };
    _Some.prototype.is_none = function () {
        return false;
    };
    _Some.prototype.match = function (p) {
        return p.some(this._);
    };
    _Some.prototype.map = function (fn) {
        var newVal;
        try {
            newVal = Some(fn(this._));
        }
        catch (e) {
            console.error("Error: " + e);
            newVal = exports.None;
        }
        return newVal;
    };
    _Some.prototype.and_then = function (fn) {
        var newVal;
        try {
            newVal = fn(this._);
        }
        catch (e) {
            console.error("Error: " + e);
            newVal = exports.None;
        }
        return newVal;
    };
    _Some.prototype.or = function (optb) {
        return Some(this._);
    };
    _Some.prototype.and = function (optb) {
        return optb;
    };
    _Some.prototype.unwrap = function () {
        if (exports.assert_none(this._)) {
            throw new ReferenceError('Cannot unwrap "null" or "undefined"');
        }
        return this._;
    };
    _Some.prototype.unwrap_or = function (def) {
        if (exports.assert_none(def)) {
            throw new ReferenceError('Cannot use "null" or "undefined" as default parameter when calling unwrap_or()');
        }
        return this._;
    };
    return _Some;
}());
exports._Some = _Some;
var _None = (function () {
    function _None() {
    }
    _None.prototype.is_some = function () {
        return false;
    };
    _None.prototype.is_none = function () {
        return true;
    };
    _None.prototype.match = function (p) {
        if (typeof p.none === 'function') {
            return p.none();
        }
        else {
            return p.none;
        }
    };
    _None.prototype.map = function (fn) {
        return new _None();
    };
    _None.prototype.and_then = function (fn) {
        return new _None();
    };
    _None.prototype.or = function (optb) {
        return optb;
    };
    _None.prototype.and = function (optb) {
        return new _None();
    };
    _None.prototype.unwrap = function () {
        throw new ReferenceError('Cannot unwrap None');
    };
    _None.prototype.unwrap_or = function (def) {
        if (exports.assert_none(def)) {
            throw new ReferenceError('Cannot use "null" or "undefined" as default parameter when calling unwrap_or()');
        }
        return def;
    };
    return _None;
}());
exports._None = _None;
function Some(_) {
    return exports.assert_some(_) ? new _Some(_) : new _None();
}
exports.Some = Some;
exports.None = new _None();
//# sourceMappingURL=index.js.map