import { Option } from '../Option';
export interface MatchPattern<O, E, T, U> {
    ok: (_: O) => T;
    err: (_: E) => U;
}
export interface Result<O, E> {
    is_ok(): boolean;
    is_err(): boolean;
    match<T, U>(p: MatchPattern<O, E, T, U>): T | U;
    map<T>(fn: (_: O | E) => T): Result<T, E>;
    unwrap(): O;
    unwrap_err(): E;
    unwrap_or(optb: O): O;
    ok(): Option<O>;
    err(): Option<E>;
}
export declare function is_ok<O, E>(_: Result<O, E>): _ is _Ok<O>;
export declare function is_err<O, E>(_: Result<O, E>): _ is _Err<E>;
export declare class _Ok<O> implements Result<O, any> {
    protected readonly _: O;
    constructor(_: O);
    is_ok(): boolean;
    is_err(): boolean;
    match<T, U>(p: MatchPattern<O, any, T, U>): T;
    map<U>(fn: (_: O) => U): _Ok<U>;
    unwrap(): O;
    unwrap_err(): never;
    unwrap_or(optb: O): O;
    ok(): Option<O>;
    err(): Option<any>;
}
export declare class _Err<E> implements Result<any, E> {
    protected readonly _: E;
    constructor(_: E);
    is_ok(): boolean;
    is_err(): boolean;
    match<T, U>(p: MatchPattern<any, E, T, U>): U;
    map<U>(fn: (_: E) => U): _Err<E>;
    unwrap(): never;
    unwrap_err(): E;
    unwrap_or<T>(optb: T): T;
    ok(): Option<any>;
    err(): Option<E>;
}
export declare function Ok<T>(_: T): _Ok<T>;
export declare function Err<T>(_: T): _Err<T>;
