"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Option_1 = require("../Option");
function is_ok(_) {
    return _.is_ok();
}
exports.is_ok = is_ok;
function is_err(_) {
    return _.is_err();
}
exports.is_err = is_err;
var _Ok = (function () {
    function _Ok(_) {
        this._ = _;
    }
    _Ok.prototype.is_ok = function () {
        return true;
    };
    _Ok.prototype.is_err = function () {
        return false;
    };
    _Ok.prototype.match = function (p) {
        return p.ok(this._);
    };
    _Ok.prototype.map = function (fn) {
        return Ok(fn(this._));
    };
    _Ok.prototype.unwrap = function () {
        return this._;
    };
    _Ok.prototype.unwrap_err = function () {
        throw new ReferenceError('Cannot call unwrap_err() on an instance of Ok');
    };
    _Ok.prototype.unwrap_or = function (optb) {
        if (Option_1.assert_none(optb)) {
            throw new ReferenceError('Cannot use "null" or "undefined" as default parameter when calling unwrap_or()');
        }
        return this._;
    };
    _Ok.prototype.ok = function () {
        return Option_1.Some(this._);
    };
    _Ok.prototype.err = function () {
        return Option_1.None;
    };
    return _Ok;
}());
exports._Ok = _Ok;
var _Err = (function () {
    function _Err(_) {
        this._ = _;
    }
    _Err.prototype.is_ok = function () {
        return false;
    };
    _Err.prototype.is_err = function () {
        return true;
    };
    _Err.prototype.match = function (p) {
        return p.err(this._);
    };
    _Err.prototype.map = function (fn) {
        return this;
    };
    _Err.prototype.unwrap = function () {
        throw new ReferenceError('Cannot call unwrap() on an instance of Err');
    };
    _Err.prototype.unwrap_err = function () {
        return this._;
    };
    _Err.prototype.unwrap_or = function (optb) {
        if (Option_1.assert_none(optb)) {
            throw new ReferenceError('Cannot use "null" or "undefined" as default parameter when calling unwrap_or()');
        }
        return optb;
    };
    _Err.prototype.ok = function () {
        return Option_1.None;
    };
    _Err.prototype.err = function () {
        return Option_1.Some(this._);
    };
    return _Err;
}());
exports._Err = _Err;
function Ok(_) {
    return new _Ok(_);
}
exports.Ok = Ok;
function Err(_) {
    return new _Err(_);
}
exports.Err = Err;
//# sourceMappingURL=index.js.map